/***************************************************************************
 *   Copyright (C) 2008 by Patrick Prokopczuk   *
 *   prokopczuk@gmx.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/**
 * \file trackball.h
 * \brief Trackball header file
 **/
#ifndef TRACKBALL_H
 #define TRACKBALL_H
 
#include <QtGui>
#include "../quaternion/quaternion.h"
#include "../vector3d/vector3d.h"

class trackball : public QObject 
{
	Q_OBJECT
	
public:
	trackball(QWidget *parent=0);
	quaternion calcQuat(QPoint p1, QPoint p2, int w, int h);
private:
	double radius; 
	quaternion q1;
	vector3d v1,v2,axis;
	double calcSphereZCoord(double x, double y, double r);
	
};
#endif
